﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IDU
{
    /// <summary>
    /// Логика взаимодействия для MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        gr682_ggiEntities1 db = new gr682_ggiEntities1();

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Click_Insert(object sender, RoutedEventArgs e)
        {
            StudentTEST student = new StudentTEST();
            student.FirstName = txtFirstName.Text;
            student.LastName = txtLastName.Text;
            db.StudentTEST.Add(student);
            db.SaveChanges();
            dgogrenci.ItemsSource = db.StudentTEST.ToList();
        }
        private void Click_Delete(object sender, RoutedEventArgs e)
        {
            int num = Convert.ToInt32(txtId.Text);
            var dRow = db.StudentTEST.Where(w => w.Id == num).FirstOrDefault();
            db.StudentTEST.Remove(dRow);
            db.SaveChanges();
            dgogrenci.ItemsSource = db.StudentTEST.ToList();
        }
        private void Click_Update(object sender, RoutedEventArgs e)
        {
            int num = Convert.ToInt32(txtId.Text);
            var uRow = db.StudentTEST.Where(w => w.Id == num).FirstOrDefault();
            uRow.FirstName = txtFirstName.Text;
            uRow.LastName = txtLastName.Text;
            db.SaveChanges();
            dgogrenci.ItemsSource = db.StudentTEST.ToList();
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            db = new gr682_ggiEntities1();
            dgogrenci.ItemsSource = db.StudentTEST.ToList();
        }

        /*public bool TableActions (string FirstName, string LastName)
        {
            gr682_ggiEntities db = new gr682_ggiEntities();
            if (!db.StudentTEST.Select(item => item.FirstName + "" + item.LastName).Contains(FirstName + "" + LastName))
            {
                MessageBox.Show("Такого студента нет в базе");
                return false;
            }

            MessageBox.Show("Студент успешно найден");
            return true;
        }*/

        public bool Insert_TEST (string FirstNameT, string LastNameT)
        {
            gr682_ggiEntities1 db = new gr682_ggiEntities1();

            if (FirstNameT == "" || LastNameT == "")
            {
                MessageBox.Show("Поля не заполнены");
                return false;
            }
            else if (db.StudentTEST.Select(item => item.FirstName + item.LastName).Contains(FirstNameT + LastNameT))
            {
                MessageBox.Show("Этот студент уже добавлен");
                return false;
            }

            StudentTEST NewStudent = new StudentTEST()
            {
                FirstName = FirstNameT,
                LastName = LastNameT
            };

            if (NewStudent == null)
            {
                MessageBox.Show("Студент не добавлен");
                return false;
            }

            db.StudentTEST.Add(NewStudent);

            try
            {
                db.SaveChanges();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
                return false;
            }
            MessageBox.Show("Студент добавлен");
            return true;
        }

        public bool Update_TEST (int Id ,string FirstNameT, string LastNameT)
        {
            gr682_ggiEntities1 db = new gr682_ggiEntities1();
            var uRow = db.StudentTEST.Where(w => w.FirstName == FirstNameT).FirstOrDefault();

            if (FirstNameT != null)
            {
                if (uRow != null)
                {

                    StudentTEST NewStudent = new StudentTEST()
                    {
                        FirstName = FirstNameT,
                        LastName = LastNameT
                    };
                }
                else
                {
                    MessageBox.Show("Студент для коректировки не найден");
                    return false;
                }
                try
                {
                    db.SaveChanges();
                }
                catch (Exception e)
                {
                    MessageBox.Show("Ошибка");
                }

                if (uRow == null)
                {
                    MessageBox.Show("Студент не добавлен");
                    return false;
                }
            }

            return true;
        }

        public bool Delete_TEST (string FirstNameT)
        {
            gr682_ggiEntities1 db = new gr682_ggiEntities1();

            if (FirstNameT != null)
            {
                var dRow = db.StudentTEST.Where(w => w.FirstName == FirstNameT).FirstOrDefault();

                if (dRow != null) db.StudentTEST.Remove(dRow);
                else return false;
                try
                {
                    db.SaveChanges();
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                    return false;
                }
            }
            return true;
        }
    }
}
